

#include "card.h"

//------------------------------------------------------------------------------------------
card::card(){
	reset();
	myCardImage.allocate(CARD_CV_W,CARD_CV_H, OF_IMAGE_GRAYSCALE);
	myCardImageFlipped.allocate(CARD_CV_W,CARD_CV_H, OF_IMAGE_GRAYSCALE);
	myCardImageThresholded.allocate(CARD_CV_W,CARD_CV_H, OF_IMAGE_GRAYSCALE);
	myCardImageThresholdedFlipped.allocate(CARD_CV_W,CARD_CV_H, OF_IMAGE_GRAYSCALE);

}
	
//------------------------------------------------------------------------------------------
int card::getSuit(){
	return suit;
}
	
//------------------------------------------------------------------------------------------
int card::getCard(){
	cardNumber = 1 + (whichCard-1) % 13;
	return cardNumber;
}
	
//------------------------------------------------------------------------------------------
void card::reset(){
	
	pta	= ptb = ptc = ptd = 0;
	good		= false;
	pixelRatio	= 0.0;
	whichCard	= -1;
	suit		= -1;
	cardNumber	= -1;
	angle		= 0.0;
	hu			= 0.0;
	
	boundingRect.x = 0;
	boundingRect.y = 0;
	boundingRect.width = 0;
	boundingRect.height = 0;
	
	for(int i = 0; i < 4; i++){
		c[i] = 0;
	}
	pctWhitePixels = 0;
}
	
//------------------------------------------------------------------------------------------
void card::setBoundingRect(ofRectangle bounding){
	memcpy(&boundingRect, &bounding, sizeof(ofRectangle));
}
	
//------------------------------------------------------------------------------------------
void card::setPoints(ofxVec2f pt1, ofxVec2f pt2, ofxVec2f pt3, ofxVec2f pt4){
	c[0] = pt1;
	c[1] = pt2;
	c[2] = pt3;
	c[3] = pt4;
	good = true;
}

//------------------------------------------------------------------------------------------
void card::drawAnalysisResults(int x, int y){
	
	// TODO: make this drawing much better 
	
	glPushMatrix();
	glTranslatef(x,y,0);
		
		/*
		 for (int j = 0; j < 3; j++){
		   if( whichCardHu[j] != -1 ){
			   ofSetColor(20, 20, 160, 190);
			   ofRect(-8, -12 + (j+1)*15, 56, 23);
			   ofSetColor(0x00FF00);	
			   ofDrawBitmapString(ofToString(whichCardHu[j]) + " " + ofToString(diffHu[j]*10, 3),  - 4,  + 2 + (1+j)*15);
		   }
		}
		 hu kind of sucked.
		 */
	
		ofSetColor(20, 20, 160, 190);
		ofRect(-8, -12 +60, 56, 23);
		ofSetColor(0x00FF00);	
		ofDrawBitmapString("pct edge white " + ofToString(pctEdgeDetectionWhite, 4),  - 4,  + 2 + 60);

		/*ofSetColor(20, 20, 160, 190);
		ofRect(-8, -12+75, 56, 23);
		ofSetColor(0x00FF00);	
		ofDrawBitmapString( ofToString((int)avgColor.x) + " " + ofToString((int)avgColor.y) + " " + ofToString((int)avgColor.z),  - 4,  + 2 + 75);
*/
	
		ofSetColor(20, 20, 160, 190);
		ofRect(-8, -12+90, 56, 23);
		ofSetColor(0x00FF00);	
		ofDrawBitmapString( bFaceCard == true ? "face card" : "number card" ,  - 4,  + 2 + 90);

		ofSetColor(20, 20, 160, 190);
		ofRect(-8, -12+105, 56, 23);
		ofSetColor(0x00FF00);	
		ofDrawBitmapString( bRedSuit == true ? "red" : "black" ,  - 4,  + 2 + 105);

	glPopMatrix();
	
}
	