#pragma once

#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXOPENCV

#include "ofMain.h"
#include "ofAddons.h"

#define MAX_CONTOURS 10000
#define NUM_CARDS 9
#define MIN_CARD_AREA 320

#define CARD_CV_W 64
#define CARD_CV_H 80


// [zach] added this... for corner detection, so we can draw the corner finder routine... otherwise, we loose it
// #include "cornerFinderBlob.h"


class card{
	
public:
	
	
	card();
	
	int		getSuit();
	int		getCard();
	void	reset();
	void	setBoundingRect(ofRectangle bounding);
	void	setPoints(ofxVec2f pt1, ofxVec2f pt2, ofxVec2f pt3, ofxVec2f pt4);
	
	void	drawAnalysisResults(int x, int y);
	
	ofxVec2f	c[4];  // can this be renamed ?
	bool		good;
	float		pixelRatio;
	
	// [zach] added some additional code here to show how close these things are:
	
	int			whichCard;
	float		diff;
	int			whichCardHu[3];
	float		diffHu[3];
	
	int			suit;
	int			cardNumber;
	int			pta;
	int			ptb;
	int			ptc;
	int			ptd;
	float		angle;
	float		hu;
	ofxVec2f	center;
	
	ofRectangle		boundingRect;
	CvMoments		Moments;
	CvHuMoments		HuMoments;	
	
	
	//-------------------------------
	// is face card and is color?
	float		pctWhitePixels;
	float		pctEdgeDetectionWhite;			// edge detection is better measure of face card ness...
	bool		bFaceCard;
	bool		bRedSuit;
	ofPoint		avgColor;
	ofImage		myCardImage;
	ofImage		myCardImageFlipped; // flipped w and h...
	
	ofImage		myCardImageThresholded;
	ofImage		myCardImageThresholdedFlipped;
	
	
};


