#pragma once

#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXOPENCV

#include "ofMain.h"
#include "ofAddons.h"

#include "card.h"

class cvCardAnalysis{
	
	public:		
		
		void setup(int cardW, int cardH);
		void getCardAsCvImage(card &theCard, ofxCvGrayscaleImage &videoFrame);
		void getCardAsCvImage(card &theCard, ofxCvGrayscaleImage &videoFrame, ofxCvColorImage &videoFrameColor);  // default params?
	
		void dynamicThreshold(int threshold = 128);
		void calculateHuMoments(card &theCard, bool bUseThresholdedFrame = true);
		void calculateCardProperties(card &theCard);  // face card, etc?

		//------------------------------
		int cardWarpW;
		int cardWarpH;
		
		ofxCvGrayscaleImage		cardImg;
		ofxCvColorImage			cardImgColor;				// needed for red detection 
		ofxCvGrayscaleImage		thresholdedFrame;
		ofxCvGrayscaleImage		thresholdedFrameDilated;	// needed for faceCard detection 
		ofxCvGrayscaleImage		cannyImage;	
	
		unsigned char *			cornerPixels;
		ofxCvGrayscaleImage		cornerMaskedImage;			// needed for red detection 		
		ofxCvGrayscaleImage		cornerImage;				// needed for red detection 
		
	
		unsigned char * threshPixels; 
	
		ofxCvContourFinder contourFinder;
	
	
};

