#ifndef _CV_MANAGER_H
#define _CV_MANAGER_H


#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXOPENCV

#include "ofMain.h"
#include "ofAddons.h"

#include "card.h"

#include "cvBlobTracker.h"
#include "contourAnalyser.h"
#include "cornerFinder.h"
#include "cardGemoetry.h"
#include "cvCardAnalysis.h"



class cvManager {
	
	public:
	cvManager();
		
	//changing cameras or switching from/to the camera mode
	//requires the app to be restarted - mabe we can change this?
	void setupCamera(int deviceNumber, int width, int height);
	void setupVideo(string videoPath);
	
	//do all our openCV allocation
	//---------------------------		
	void setupCV();
	
	//good for adjusting the color balance, brightness etc
	void openCameraSettings();
	void toggleVideoPlayback();
	void useCamera();
	void useVideo();

	//the heart of the beast - where we process 
	//-------------------------------------------------------------------------------
	
	void	passInImageToFindCardsIn	(ofImage &imgToLookAt);
	int		findCards					(card * cards, int threshold, int minSize, int maxSize, bool bUseImageNotVideo = false );

	void	resetBlobID();
	void	draw(float x, float y);


	cornerFinder corner;
	cardGemoetry cardGeom;	
	cvCardAnalysis cardAnal;
	cvBlobTracker blobTrack;
	contourAnalyser contAna;
	
	ofVideoPlayer  	VP;
	ofVideoGrabber 	VG;
	
	ofxCvColorImage			ImageFrame;				// sometimes we will find cards in a passed in image, this is how. 
	ofxCvColorImage			VideoFrame;
	ofxCvGrayscaleImage		GreyFrame;
	ofxCvGrayscaleImage		PresenceFrame;
	ofxCvContourFinder		Contour;
	
	ofxCvContourFinder		ContourForZach;

		
	bool					bCameraSetup, bVideoSetup;
	bool					bSetup;	
	float					cornerSensitivity;
	float					activityThresh;
	int						W;
	int						H;	
	int						which;

};



#endif